
#include <ndds/ndds_c.h>
#include <ndds/ndds_cpp.h>
#include <iostream>

namespace test {
const DDS_StatusMask MASK = DDS_INCONSISTENT_TOPIC_STATUS | DDS_SAMPLE_LOST_STATUS | DDS_SAMPLE_REJECTED_STATUS | DDS_SUBSCRIPTION_MATCHED_STATUS | DDS_LIVELINESS_CHANGED_STATUS | DDS_REQUESTED_INCOMPATIBLE_QOS_STATUS | DDS_PUBLICATION_MATCHED_STATUS | DDS_OFFERED_INCOMPATIBLE_QOS_STATUS | DDS_LIVELINESS_LOST_STATUS;

class LoggedParticipantListener : public DDSDomainParticipantListener {

	void on_inconsistent_topic(DDSTopic* topic, const DDS_InconsistentTopicStatus& status) override {
		std::cerr << "on_inconsistent_topic\n";
	}

	void on_liveliness_changed(DDSDataReader* reader, const DDS_LivelinessChangedStatus& status) override {
		std::cerr << "on_liveliness_changed\n";
	}

	void on_requested_incompatible_qos(DDSDataReader* reader, const DDS_RequestedIncompatibleQosStatus& status) override {
		std::cerr << "on_requested_incompatible_qos\n";
	}

	void on_sample_rejected(DDSDataReader* reader, const DDS_SampleRejectedStatus& status) override {
		std::cerr << "on_sample_rejected\n";
	}

	void on_sample_lost(DDSDataReader* reader, const DDS_SampleLostStatus& status) override {
		std::cerr << "on_sample_lost\n";
	}

	void on_subscription_matched(DDSDataReader* reader, const DDS_SubscriptionMatchedStatus& status) override {
		std::cerr << "on_subscription_matched\n";
	}

	void on_offered_incompatible_qos(DDSDataWriter* writer, const DDS_OfferedIncompatibleQosStatus& status) override {
		std::cerr << "on_offered_incompatible_qos\n";
	}

	void on_liveliness_lost(DDSDataWriter* writer, const DDS_LivelinessLostStatus& status) override {
		std::cerr << "on_liveliness_lost\n";
	}

	void on_publication_matched(DDSDataWriter* writer, const DDS_PublicationMatchedStatus& status) override {
		std::cerr << "on_publication_matched\n";
	}
};
	

DDS_DomainParticipant* CreateOldParticiapnt(int id)
{
	auto old_part = DDSDomainParticipantFactory::get_instance()->create_participant( id, DDS_PARTICIPANT_QOS_DEFAULT,
																					 new LoggedParticipantListener, MASK);
	return old_part->get_c_domain_participantI();
}

} // namespace test

